package pinball;

import java.awt.*;

/**
 * Used for displaying error messages. 
 */
public class ErrorDialog extends Dialog{
	/** The button to say that the user has read the dialog. */
	private Button ok;

	/**
	 * Create the window with the following message.
	 *
	 * @param parent Frame who called the error.
	 * @param message the message to be displayed.
	 */
	public ErrorDialog(Frame parent, String message) {
		super(parent,"ERROR",true);
		setLayout(new GridLayout(2,1,5,0));
		setSize(300,200);
		add(new Label(message,Label.CENTER));
		add(ok=new Button("OK"));
		setVisible(true);
	}
	
	/** The events for the window. When the user presses OK, close the window.*/
	public boolean action(Event e, Object arg) {
			
		Object target = e.target;
		
		/* When the user presses ok close the window. */
		if(target==ok) {
			dispose();
			return true;
		}
		
		return false;
	}
}
