package pinball.part;

import pinball.*;
import pinball.buffer.*; 
import pinball.server.*;
import pinball.player.*;

import java.io.*;

/**
 * Used to start the a game of pinball. 
 */
public class StartButton {
	/** Used to control the startButton. */
	private transient FileOutputStream startButton;
	
	/** Code sent to press the start button. */
	private final int START = 4;

	/** Make a start button to start the pinball game. */
	public StartButton(){
		/* If playing from a file, don't make the startButton. */
		if(GameOptions.play())
			return;

		/* Make startButton. */
		try {startButton =  new FileOutputStream("/dev/labpcdio2");}
		catch (IOException e){
			System.err.println("StartButton ERROR "+e);
			System.exit(1);
		}
		System.err.println("StartButton Made.");
	}		
	
	/**
	 * Press the start button. 
	 */
	public void press() {
		if(GameOptions.running() && !GameOptions.play()) {
			try{	startButton.write(START);
				Thread.sleep(100);
				startButton.write(0);
			}
			catch (Exception e){}
		}
	} 				

}
