package pinball.player.draw;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;

import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;


/**
 * This is where the picture is displayed to.
  */
public class DrawPost extends Post {
	/** 
	 * Initalize the DrawingBoard. 
	 *
	 * @param buffer the first in the series of infomation buffers.
	 */
	public DrawPost(Buffer buffer){	
		super(buffer);
	}
	
	/**
	 * Create the canvas drawn to.
	 *
	 * @param x Width of canvas.
	 *
	 * @param y Height of canvas.
	 *
	 * @return the canvas to drawn on.
	 */
	public DrawingCanvas canvas(int x,int y) {
		this.canvas=new DrawDrawingCanvas(x,y);
			      	
		return this.canvas;
	}
	
}
