package pinball.player.resize;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;
import pinball.player.standard.*;
import pinball.player.network.*;
import pinball.player.remote.*;


import java.util.*;
import java.io.*;
import java.awt.*;

/** 
 * Player who resizes the camera's frame to see only the flipping area while ball's in play.
 */
public class ResizePlayer extends StdPlayer{
	/** ID for the class. */
	static { id="rsz"; }


	/** 
	 * Start up the program. Takes command line arguments.
   	 * Takes the following command line arguments:
	 * -s for server mode.
	 * -c for client mode.	 
	 */
	public static void main(String args[]) {		
		StdPlayer player=new ResizePlayer();
		player.makeIt(player,args);
	} 
	
	
	/** 
	 * Get the strategy thread for the player. 
	 *
 	 * @param buffer the first buffer in the series of buffers for the system.
	 * @param gameStats the area to write the game stats to.
 	 * @param camera the camera for the system.
	 *
 	 * @return strategy thread.
	 */
	public Strategy localStrategy(Buffer buffer,TextArea gameStats, Camera camera) {
		return new ResizeStrategy(buffer,gameStats, camera);
	}
	
	
	/** 
	 * Get the strategy thread for the player. 
	 *
 	 * @param buffer the first buffer in the series of buffers for the system.
	 * @param gameStats the area to write the game stats to.
 	 *
 	 * @return strategy thread.
	 */
	public Strategy clientStrategy(Buffer buffer,TextArea gameStats) {
		return new ResizeRemoteStrategy(buffer,gameStats);
	}
	
}	
	

