package pinball.player.resize;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;


import java.util.*;
import java.io.*;
import java.awt.*;


/** 
 * The strategy thread for the player. 
 */
public class ResizeStrategy extends Strategy {
	/* Old dimentions of the frame. */
	
	/** Old width. */
	protected int oldWidth;

	/** Old Height. */
	protected int oldHeight; 
	
	/** Old Xoffset. */
	protected int oldXOffset; 
	
	/** Old Yoffset. */	
	protected int oldYOffset; 
	
	/** Old flipperZone. */
	protected int oldFlipperZone;
	
	/** Did it go to full screen. */
	protected boolean resizedFull=true;
	
	/** Did it go to small screen. */
	protected boolean resizedSmall=false;
		
	/** For extended classes. */
	public ResizeStrategy() {
	}
		
	
	/** 
	 * The strategy thread for the player. 
	 *
 	 * @param buffer the first buffer in the series of buffers for the system.
	 * @param gameStats the area to write the game stats to.
  	 * @param camera the camera for the system.
	 */	
	public ResizeStrategy(Buffer buffer,TextArea gameStats, Camera camera) {
		id="Resize";
		this.stub=new Stub(buffer,gameStats,this,camera);
		stub.setPriority(Thread.NORM_PRIORITY);
		
		boarder=4;
		stub.boarder(boarder);
		System.err.println("Strategy: "+id);	
	}

	/**
	 * The option for this strategy does the resizing. 
	 */
	public void option() {
		if(firstTime) {		
			/* Save the original size of the image. */
			oldWidth=buffinfo.width();
			oldHeight=buffinfo.height();
			oldXOffset=buffinfo.XOffset();
			oldYOffset=buffinfo.YOffset();
 			oldFlipperZone=stub.flipperZone();	
			flipperHeight=0;
			stub.headerInfo(stub.number()+" flipperHeight="+flipperHeight);
			//outZone=buffinfo.YOffset()+ysize-fromBottom;
			stub.headerInfo(stub.number()+" outZone="+outZone);
			stub.headerInfo(stub.number()+" top="+fromTop);
				stub.headerInfo(stub.number()+" flipperDistance="+boarder);
			top=oldYOffset+fromTop;
			stub.topBottom(top,outZone);
//			System.err.println("OUTZONE "+outZone);
			firstTime=false;						
		}	
			
//		System.err.println("In Play: "+stub.statsBallInPlay()+" !resized"+!resizedFull+" bottom="+outZone);							
		 
		/* Make small. */					
		if(stub.statsBallInPlay() && !resizedFull) {
			/* Make new image size. */
			stub.resize(oldWidth,oldHeight-oldFlipperZone,0,oldFlipperZone);
//			System.err.print("RESIZE "+oldWidth+" "+(oldHeight-oldFlipperZone));
 			
			resizedFull=true;
			resizedSmall=false;
			
			System.err.println("*********************Make Small");
			System.err.println("Resize requested by frame: "+buffinfo.number());
		}
		
		/* Make original. */
		else if(!stub.statsBallInPlay() && !resizedSmall) {
			stub.resize(oldWidth,oldHeight,oldXOffset,oldYOffset);
			top=fromTop;
			
//			System.err.print("RESIZE "+oldWidth+" "+oldHeight);
			
			resizedSmall=true;
			resizedFull=false;
			System.err.println("*********************Make BIG");
		}						
	}
}
